(function() {
    var db,transaction,objStore, datastore, keyRange, cursorRequest, object, result;
    indexedDB = window.indexedDB;
    datastore = 'vpnsecure';
    db = '';
    upgradereq = false;

    opendb = function(callback) {
      // Database version.
      var version = 1;

      // Open a connection to the datastore.
      var request = indexedDB.open(datastore, version);

      // Handle datastore upgrades.
      request.onupgradeneeded = function(e) {
        db = e.target.result;
        e.target.transaction.onerror = this.onerror;

        // Delete the old datastore.
        if (db.objectStoreNames.contains('user')) {
          db.deleteObjectStore('user');
        }
        if (db.objectStoreNames.contains('gui')) {
          db.deleteObjectStore('gui');
        }
        if (db.objectStoreNames.contains('openvpn')) {
          db.deleteObjectStore('openvpn');
        }
        if (db.objectStoreNames.contains('route')) {
          db.deleteObjectStore('route');
        }
        if (db.objectStoreNames.contains('servers')) {
          db.deleteObjectStore('servers');
        }
        if (db.objectStoreNames.contains('network')) {
          db.deleteObjectStore('network');
        }
        /* if (db.objectStoreNames.contains('securebind')) {
          db.deleteObjectStore('securebind');
        } */

        // Create a new datastore.
        db.createObjectStore('user', {
          keyPath: 'key'
        });

        var routes = db.createObjectStore('route', {
          keyPath: 'key'
        });
        routes.createIndex('by_option', "option", {unique: true});

        var openvpn = db.createObjectStore('openvpn', {
          keyPath: 'key'
        });
        openvpn.createIndex('by_option', "option", {unique: true});

        var securebind = db.createObjectStore('securebind', {
          keyPath: 'key'
        });
        securebind.createIndex('by_option', "option", {unique: true});

        db.createObjectStore('gui', {
          keyPath: 'key'
        });

        db.createObjectStore('servers', {
          keyPath: 'key'
        });
        db.createObjectStore('network', {
          keyPath: 'key'
        });
        upgradereq = true;
      };

      // Handle successful datastore access.
      request.onsuccess = function(e) {
        // Get a reference to the DB.

        //datastore = e.target.result;
        db = e.target.result;
        if(upgradereq) {
          var disableinternet = { disableinternet: false, key: 'disableinternet'};
          insertdb(disableinternet, 'gui', function(data){});

          var dnsleakfix = { dnsleakfix: true, key: 'dnsleakfix'};
          insertdb(dnsleakfix, 'gui', function(data){});

          var defaultovpnop = { defaultovpnop: true, key: 'defaultovpnop'};
          insertdb(defaultovpnop, 'gui', function(data){});

          var obfsproxy = { obfsproxy: false, key: 'obfsproxy'};
          insertdb(obfsproxy, 'gui', function(data){});

           var ipv6 = { ipv6: false, key: 'ipv6'};
          insertdb(ipv6, 'gui', function(data){});

          var openstartup = { openstartup: false, key: 'openstartup'};
          insertdb(openstartup, 'gui', function(data){});

          var connectstartup = { connectstartup: false, serverid: '0', key: 'connectstartup'}
          insertdb(connectstartup, 'gui', function(data){});

          var gateway = { gateway: '', startup: false, key: 'gateway'};
          insertdb(gateway, 'network', function(data){});

            insertdb(gateway, 'openvpn', function(data){});

          var user = { username: '', password: '', save: true, key: 'user' };
          var userpasssave = { userpasssave: true, key: 'userpasssave'};

            insertdb(user, 'user', function(data) {
              insertdb(userpasssave, 'gui', function(data) {
            });
          });
        }
        // Execute the callback.
        callback('done');
      };
      // Handle errors when opening the datastore.
      request.onerror = this.onerror;
    };
    fetchkeyU = function(keystore, object, key, callback) {
      transaction = db.transaction([keystore], 'readonly') ;
      objStore = transaction.objectStore(keystore);
      var index = objStore.index('key');
      var request = index.get(key);
      request.onsuccess = function() {
        var matching = request.result;
        if(matching != undefined) {
          callback(true);
        } else {
          callback(false);
        }
      }
    }
    fetchkey = function(keystore, object, key, callback) {
      transaction = db.transaction([keystore], 'readonly') ;
      objStore = transaction.objectStore(keystore);
      var index = objStore.index('by_option');
      var request = index.get(key);
      request.onsuccess = function() {
        var matching = request.result;
        if(matching != undefined) {
          callback(true);
        } else {
          callback(false);
        }
      }
    }
    deleteKey = function(keystore, key, callback) {
      transaction = db.transaction([keystore], 'readwrite');
      objectStore = transaction.objectStore(keystore);
      var index = objectStore.index('by_option');
      var request = index.delete(key);
      request.onsuccess = function() {
        var yes = request.result;
      }
    }
    fetchdb = function(keystore, callback) {
      transaction = db.transaction([keystore], 'readwrite');
      objStore = transaction.objectStore(keystore);

      keyRange = window.IDBKeyRange.lowerBound(0);
      cursorRequest = objStore.openCursor(keyRange);

      object = [];

      transaction.oncomplete = function(e) {
        // Execute the callback function.
        callback(object);
      };

      cursorRequest.onsuccess = function(e) {
        result = e.target.result;

        if (!!result == false) {
          return;
        }
        object.push(result.value);

        result.continue();
      };

      cursorRequest.onerror = this.onerror;
    };

    deletedb = function(id, keystore, callback) {
      transaction = db.transaction(keystore, 'readwrite');
      var objStore = transaction.objectStore(keystore);

      var request = objStore.delete(id);
      request.onsuccess = function(e) {
        callback(true);
      }

      request.onerror = function(e) {
        callback(false);
      }
    };
    updatedb = function(obj, keystore, callback) {
      transaction = db.transaction(keystore, 'readwrite');
      objStore = transaction.objectStore(keystore);
      request = objStore.add(obj);
      request.onsuccess = function(e) {
        // Execute the callback function.
        callback(request);
      };

      // Handle errors.
      request.onerror = this.onerror;
    }
    insertdb = function(obj, keystore, callback) {
      // Get a reference to the db.
      // Initiate a new transaction.
      transaction = db.transaction(keystore, 'readwrite');

      // Get the datastore.
      objStore = transaction.objectStore(keystore);

      // Create the datastore request.
      request = objStore.put(obj);

      // Handle a successful datastore put.
      request.onsuccess = function(e) {
        // Execute the callback function.
        callback(request);
      };

      // Handle errors.
      request.onerror = this.onerror;
    };

    exports.insert = insertdb;
    exports.opendb = opendb;
    exports.fetchdb = fetchdb;
    exports.deletedb = deletedb;
    exports.fetchkey = fetchkey;
    exports.fetchkeyU = fetchkeyU;
    exports.deleteKey = deleteKey;
}).call(this);