var spawn = require('child_process').spawn;
var util = require('util');
var net = require('net');
var fs = require('fs');
var path = fs.realpathSync('.');
var openvpnLogFile = fs.createWriteStream(path + '/openvpn.log');
var keypassword = false;
var thispid = false;
var connectingopenvpn = false;
var telo = {};
telo.socket = new net.Socket();
telo.socket.setEncoding('ascii');
var socketconn = false;

OpenvpnClient();

function OpenvpnClient() {

    if(connectingopenvpn) {
        return;
    }
    fs.truncate(path + '/openvpn.log', 0, function(err){ console.log(err); });
    this.dir = __dirname;
    var self = this;
    this.proto = process.argv[5];
    this.username = process.argv[2];
    this.line = 0;
    this.buffer = null;
    this.password = process.argv[3];
    this.server = process.argv[4];
    this.port = process.argv[6];

            this.config = 'default.ovpn';
            this.openvpnObj = ['--config',this.dir+'\\config\\'+this.config,'--remote',this.server, this.port,'--proto',this.proto, '--ca', this.dir+'\\config\\ca.crt', '--cert', this.dir+'\\config\\' + this.username + '.crt', '--key', this.dir+'\\config\\' + this.username + '.key', '--dh', this.dir+'\\config\\dh2048.pem', '--win-sys', 'env'];


        console.log('hit connect');
        if (this.connected) {
            disconnectOpenVPN();
            keypassword=false;
            return;

        }


        connectingopenvpn = true;
        keypassword = true;
        util.log('Connecting to '+ this.server);
                this.openvpns = {};
                this.openvpns = spawn(this.dir+'\\windows\\openvpn.exe', this.openvpnObj);
                console.log(this.dir+'\\windows\\openvpn.exe', this.openvpnObj);
        console.log('connecting');
        setupEvents(this);
};


function setupEvents(self) {
    console.log('setupEvents');
    var result;
    var t =0;
    var cachedPassword = null;
    var prompts = 0;

    self.openvpns.stdout.on('data', function(data) {
        var pid = self.openvpns.pid;
        //console.log('waiting for data');
        var ok = false;
        if(!data) throw err;
        var line = data.toString();
        openvpnLogFile.write(line);
        console.log('log:' +line);
        //return

        if(line.indexOf('Windows route add command failed') >1) {
            console.log('bind fail');
            //spawn('sudo',['kill', '-9', 'openvpn']);
              disconnectOpenVPN();
              keypassword=false;
              return;
        }
        if(line.indexOf('MANAGEMENT: Socket bind failed on local address 127.0.0.1:1337') >1) {
            console.log('bind fail');
            disconnectOpenVPN();
            keypassword=false;
            switch(self.ostype) {
                case 'win32':
                    spawn('taskkill', ['/F', '/IM', 'openvpn.exe']);
                break
            }

            return;
            //spawn('sudo',['kill', '-9', 'openvpn']);

            //self.emit('exit');
        }
        if(line.indexOf('WSAECONNRESET') > 1) {
            disconnectOpenVPN();
            keypassword=false;
            return;

        }
        if(line.indexOf("Initialization Sequence Completed With Errors") > 1) {

            disconnectOpenVPN();
            keypassword=false;
            return;
        }
        //console.log(result);
        if(line.indexOf("Initialization Sequence Completed") > 1) {
            console.log('wo0t connected');
            self.connected = true;
            connectingopenvpn = false;
        }
        if(keypassword) {
            if(line.indexOf("OpenVPN 2.2.2")>1) {
                keypassword = false;
                socketconn = true;
                console.log('starting socket to openvpn daemon');
                createOpenVPNConnection(function(data) {});
            }
        }
    });
    self.openvpns.on('uncaughtException', function (err) {
        console.log('uncaught');
        if(err) {
            self.emit("exit");
        }
    });

    self.openvpns.on("exit", function (err) {
        console.log('OpenVPN exiting', err);
        self.connected=false;
        connectingopenvpn = false;
        self.removeAllListeners('data');
        self.openvpns.stdout.removeAllListeners('data');
        self.openvpns.removeAllListeners('data');
        self.openvpns.removeAllListeners('uncaughtException');
        keypassword=false;

        /* telo.socket.destroy();
        telo = {};
        telo.socket = new net.Socket();
        telo.socket.setEncoding('ascii'); */
        console.log(self.protect);
        return self.emit('close');
    });

    self.openvpns.on("error", function(err) {
        console.log('Internal Error' + err);
        self.emit("exit");
    });
}
function createOpenVPNConnection(cb) {
    if(socketconn) {
            var count = 0;

            /*telo.socket.setNoDelay(); */
             setTimeout( function (){
                telo.socket.connect(1337, '127.0.0.1', function() {});
                socketconn = false;
            }, 1000);
            telo.socket.on('error', function(exception) {
                //self.emit('exit');
                if(count < 10) {
                telo.socket.connect(1337, '127.0.0.1', function() {
                });
                } else {

                }
                count++;
                telo = {};
                console.log('telo socket failure:' + exception);

            });
            telo.socket.on('end', function() {
                console.log('telo-socket-end');
                socketconn = false;
                telo.socket.destroy();
                telo.socket.end();
                //telo = {};
            });
            telo.socket.on('close', function() {
                console.log('telo-socket-close');
                socketconn = false;
                telo.socket.destroy();
                telo = {};
                telo.socket = new net.Socket();
                telo.socket.setEncoding('ascii');
                //telo = {};
            });
            telo.socket.on('timeout', function() {
                socketconn = false;
                console.log('timeout connecting to socket');
                telo.socket.end();
                telo.socket.destroy();
                //telo = {};
            });
             telo.socket.on('connect', function () {
            console.log('Established connection, registering...');
            setTimeout(function () {
               console.log('connected to socket');

               cb(true);
            }, 1000);

            });
    }
}

function privateKey(pass, cb) {
    telo.socket.write('password \'Private Key\' "' + pass +'"\r\n', function() {keypassword = false;});
}

function disconnectOpenVPN() {
    setTimeout(function () {
      telo.socket.write('signal SIGTERM\r\n');

            //telo = {};
            console.log('telo-socket-destory-disconnectopenvpn')
            keypassword = false;
            socketconn = true;

    }, 2000);
}


function getDomainIP(hostname, cb) {
       dns.lookup(hostname, function (err, add, fam) {
           if (err)
           {
                    console.log("The error = ", JSON.stringify(err));
                    return cb(false);
           }
           return cb(add);
       });
}






require('util').inherits(OpenvpnClient, require('events').EventEmitter);
module.exports=OpenvpnClient;
exports.disconnectOpenVPN = disconnectOpenVPN;
/* module.exports._class = OpenvpnClient;*/
